<?php
/*
Plugin Name:Tw Quickly(日本語版)
Plugin URI:https://hanauta-apron.com/diary/tw-quickly/
Description:記事編集画面からその記事をワンクリックでツイートできるプラグインです。編集画面内のリンクをクリックすることで、タイトル＋URLの文章が表示されます。ハッシュタグの追加など、自由にツイートが編集できるのが魅力です。
Version:1.0
Author:杉本一心
Author URI:https://hanauta-apron.com/diary/
License:CC BY-NC-SA 4.0
*/

////////////////////////////////////////////////////////////////////
// 特権管理者、管理者、編集者、投稿者の何れでもない場合は無視
//カスタムフィールドの見た目（入力欄等）を追加する
function hook_func_for_metabox(){
    if (is_super_admin() || current_user_can('administrator') || current_user_can('editor') || current_user_can('author')) {
        // ① メタボックスの特性を定義する
        add_meta_box( 
            'metabox_div_id',//メタボックスのdivに指定されるID
            'Tw Quickly(日本語版)', //タイトル
            'html_for_metabox_1_func', //表示用のHTMLを出力するphp関数（下で定義）
            'post', //どのタイプの記事入力画面で表示するか
            'side',
            'high'
        );
    }
}
// ② メタボックスの中身を実装する
function html_for_metabox_1_func($post){
    if (is_super_admin() || current_user_can('administrator') || current_user_can('editor') || current_user_can('author')) {
        // 投稿のタイトルを取得
        $title = sanitize_text_field($post->post_title);
        htmlspecialchars($title, ENT_QUOTES, 'UTF-8');
        // 投稿のURLを取得
        $link = get_permalink($post_ID);
        htmlspecialchars($link, ENT_QUOTES, 'UTF-8');
        $aryTwitter = [];
        $aryTwitter['text'] = $title;
        $aryTwitter['url'] = $link;
        $twitter_url = 'https://twitter.com/share?';
        $twitter_url .= implode('&', array_map(function($key, $value){return $key.'='.$value;}, array_keys($aryTwitter), array_values($aryTwitter)));
        $tweet = '<a href="'.$twitter_url.'" target="_blank" rel="noopener">ツイートする</a>';
        echo $tweet;
    }
}
// ④ カスタムフィールド用のメタボックスを追加する
add_action('admin_menu', 'hook_func_for_metabox');

?>